using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 动态文件的版块列表编译部分
    /// </summary>
    public class 编译扩展_动态文件_版块列表 : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_动态文件_版块列表(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 动态文件_版块列表_一页显示记录数 = 0;

        public String 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面=@""" + 编译器.文件名称.Replace("\"", "\"\"") + @""";
	//参数
	private int 所属版块;
	private int 排序;
	private String 版块名称="""";
	private int 上级版块;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?ID=""+所属版块+""&order=""+排序+""&page=""+页码,访问.用户[""标识""].ToString()));
	}
	private String 生成余下全部地址()
	{
		return """";
	}
";
            String 返回值 = "";
            返回值 += @"	排序=Convert.ToInt32(Request.QueryString[""order""]);
	所属版块=Convert.ToInt32(Request.QueryString[""ID""]);
	if(所属版块!=0)
		版块名称=常用.获取版块名称(所属版块);
";
            String 随机值=常用.随机字符(8);
            返回值 += @"	DataSet 数据" + 随机值 + @"=(DataSet)Application[""UUN_UUN3G_LunTanBanKuai""];
	for(int i=0;i<数据" +随机值+@".Tables[0].Rows.Count;i++)
	{
		DataRow 行=数据"+随机值+@".Tables[0].Rows[i];
		if(Convert.ToInt32(行[""ID""])==所属版块)
			上级版块=Convert.ToInt32(行[""所属版块""]);
	}
";
            返回值+=@"
	一页显示记录数=获取一页显示记录数();
	跳页表单项=""<postfield name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<postfield name=\""ID\"" value=\""""+
		所属版块+
		""\"" />""+
		""<postfield name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
	_3G跳页表单项=""<input type=\""hidden\"" name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<input type=\""hidden\"" name=\""ID\"" value=\""""+
		所属版块+
		""\"" />""+
		""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
";
            返回值 += 生成版块列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }

        private String 生成版块列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"社区_论坛_版块] WHERE [显示状态]='1'\"+(所属版块!=0?\" AND [所属版块]=\"+所属版块:\"\");\r\n";

            if (!是否数量)
            {
                返回值 += "\t\t" + 语句名称 + "SQL+=\" ORDER BY \";\r\n";
                返回值 += @"
		switch (排序)
		{
			case 0:
				" + 语句名称 + @"SQL += ""[创建时间]"";
				break;
			case 1:
				" + 语句名称 + @"SQL += ""[创建时间] DESC"";
				break;
			case 2:
				" + 语句名称 + @"SQL += ""[排序]"";
				break;
			case 3:
				" + 语句名称 + @"SQL += ""[贴子数] DESC"";
				break;
			case 4:
				" + 语句名称 + @"SQL += ""[回贴数] DESC"";
				break;
			case 5:
				" + 语句名称 + @"SQL += ""[今日发贴数] DESC"";
				break;
			case 6:
				" + 语句名称 + @"SQL += ""[今日回贴数] DESC"";
				break;
			default:
				" + 语句名称 + @"SQL += ""[最后发贴时间] DESC"";
				break;
            }
";
            }
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            return 返回值;
        }

        public string 编译公共标签(string 代码)
        {
            switch (代码)
            {
                case "当前页":
                    return "\t\t返回值.Append(当前页);\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数);\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数);\r\n";
                case "版块名称":
                    return "\t\t返回值.Append(版块名称);\r\n";
                default:
                    return "";
            }
        }

        public string 编译模板方法(string 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "上级版块列表":
                    return 编译模板方法_动态文件_上级版块列表(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "上级版块代码":
                    return 编译模板方法_动态文件_上级版块代码(属性数组[0]);
                case "_版块列表":
                    return 编译模板方法_动态文件_版块列表(属性数组[0],
                        属性数组[1],
                        属性数组[2],
                        Convert.ToInt32(属性数组[3]),
                        属性数组[4]);
                case "列表分页":
                    return 编译模板方法_动态文件_列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 编译模板方法_动态文件_分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }

        private String 编译模板方法_动态文件_上级版块列表(int 排序, String 代码)
        {
            String 返回值 = "";
            String 随机值 = 常用.随机字符(8);

            编译器.方法库 += "\tprivate String 生成上级版块列表代码" + 随机值 + "(DataSet 数据,int ID)\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(ID!=0)\r\n";
            编译器.方法库 += "\t\t{\r\n";
            编译器.方法库 += "\t\t\tString 返回值=\"\";\r\n";
            编译器.方法库 += "\t\t\tString 版块名称=\"\";\r\n";
            编译器.方法库 += "\t\t\tint 上级版块=0;\r\n";
            编译器.方法库 += "\t\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            编译器.方法库 += "\t\t\t{\r\n";
            编译器.方法库 += "\t\t\t\tDataRow 行=数据.Tables[0].Rows[i];\r\n";
            编译器.方法库 += "\t\t\t\tif(Convert.ToInt32(行[\"ID\"])==ID)\r\n";
            编译器.方法库 += "\t\t\t\t{\r\n";
            编译器.方法库 += "\t\t\t\t\t版块名称=Convert.ToString(行[\"版块名称\"]);\r\n";
            编译器.方法库 += "\t\t\t\t\t上级版块=Convert.ToInt32(行[\"所属版块\"]);\r\n";
            编译器.方法库 += "\t\t\t\t}\r\n";
            编译器.方法库 += "\t\t\t}\r\n";
            Hashtable 属性列表 = new Hashtable();
            属性列表.Add("版块名称", "Server.HtmlEncode(版块名称)");
            属性列表.Add("地址", @"Server.HtmlEncode(常用.处理地址(当前页面+""?ID=""+ID+""&order=""+排序,访问.用户[""标识""].ToString()))");
            编译器.方法库 += 编译器.生成代码项(属性列表, 代码, "返回值");
            if (排序 == 0)
                编译器.方法库 += "\t\t\t\treturn 生成上级版块列表代码" + 随机值 + "(数据,上级栏目)+返回值;\r\n";
            else
                编译器.方法库 += "\t\t\t\treturn 返回值+生成上级版块列表代码" + 随机值 + "(数据,上级栏目);\r\n";
            编译器.方法库 += "\t\t}\r\n";
            编译器.方法库 += "\t\telse\r\n";
            编译器.方法库 += "\t\t\treturn \"\";\r\n";
            编译器.方法库 += "\t}\r\n";
            返回值 += "\t\tif(上级栏目!=0)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += "\t\t\tDataSet 数据" + 随机值 + "=(DataSet)Application[\"UUN_UUN3G_NeiRongLanMu\"];\r\n";
            返回值 += "\t\t\t返回值.Append(生成上级版块列表代码" + 随机值 + "(数据" + 随机值 + ",上级版块));\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_动态文件_上级版块代码(String 代码)
        {
            String 返回值 = "";
            返回值 += "\t\tif(上级版块!=0)\r\n";
            返回值 += "\t\t{\r\n";

            Hashtable 属性列表 = new Hashtable();
            属性列表.Add("版块名称", "Server.HtmlEncode(版块名称)");
            属性列表.Add("地址", @"Server.HtmlEncode(常用.处理地址(当前页面+""?ID=""+上级版块+""&order=""+排序,访问.用户[""标识""].ToString()))");

            返回值 += 编译器.生成代码项(属性列表, 代码);

            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_动态文件_版块列表(String 格式, String 交替格式, String 空记录代码, int 字数,String 时间格式)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("版块地址", "ID,外部链接地址");
            必须字段.Add("最后发贴作者地址", "最后发贴作者ID");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录数+i+1");
            字段代码.Add("版块地址", @"行[""外部链接地址""].ToString()!=""""?Server.HtmlEncode(常用.处理地址(行[""外部链接地址""].ToString(),访问.用户[""标识""].ToString())):Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Board.aspx?ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("版块名称", @"Server.HtmlEncode(行[""版块名称""].ToString())");
            字段代码.Add("版块简介", @"Server.HtmlEncode(常用.截取字符串(行[""版块简介""].ToString(),100))");
            字段代码.Add("创建时间", @"Convert.ToDateTime(行[""创建时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后发贴时间", @"Convert.ToDateTime(行[""最后发贴时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后发贴作者地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"User.aspx?ID=""+行[""ID""]+""&rurl=""+Server.UrlEncode(Request.Url.ToString()),访问.用户[""标识""].ToString()))");
            字段代码.Add("最后发贴作者昵称", @"Server.HtmlEncode(行[""最后发贴作者昵称""].ToString())");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 版块列表" + 随机值 + "()\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(总记录数<1)\r\n";
            编译器.方法库 += "\t\t\t返回值.Append(@\"" + 空记录代码.Replace("\"", "\"\"") + "\");\r\n";
            编译器.方法库 += 生成版块列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t版块列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_动态文件_列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                (编译器.文件名称.StartsWith(程序.安装位置 + "club/", StringComparison.OrdinalIgnoreCase) ? "Club" : "Content"),
                "Page", ID, 无分页代码);
        }

        private String 编译模板方法_动态文件_分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                动态文件_版块列表_一页显示记录数 = 一页显示记录数;
            return "";
        }

        public string 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{";
            if (动态文件_版块列表_一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 动态文件_版块列表_一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }
    }
}